﻿BabelFu = LibStub("AceAddon-3.0"):NewAddon("FuBar_BabelFu", "AceHook-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local tablet = LibStub('LibQTip-1.0')

---------------------------------------------
-- CONSTANTS                               --
---------------------------------------------
local defaults = {
	char = {
		language = nil,
		types = {
			["SAY"] = true,
			["YELL"] = true,
			["PARTY"] = true,
			["GUILD"] = true,
			["OFFICER"] = true,
			["RAID"] = true,
		}
	}
}

local dataobject = {
	type="data source",
	text="Loading...",
	icon="Interface\\AddOns\\FuBar_BabelFu\\icon",
	OnClick= BabelFu.Cycle,
	OnEnter= BabelFu.TooltipOnEnter,
	OnLeave= BabelFu.TooltipOnLeave,
}

---------------------------------------------
-- EVENTS                                  --
---------------------------------------------
function BabelFu:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("BabelFuDB", defaults)
	ldb:NewDataObject("BabelFu", dataobject)
end

function BabelFu:OnEnable()
	self:RawHook("SendChatMessage","Translate",true)
end

function BabelFu.TooltipOnEnter(self)
	-- self is a "GameTooltip"
	local tooltip = tablet:Acquire("BabelFu",1,"CENTER")
	self.tooltip = tooltip

	tooltip:AddHeader("Languages")

	for x=1, GetNumLanguages() do
		tooltip:AddLine(GetLanguageByIndex(x))
		tooltip:SetLineScript(tooltip:GetLineCount(),"OnMouseUp",
		    BabelFu.OnLanguageClick,x)
	end
end

function BabelFu.TooltipOnLeave(self)
	-- self is a "GameTooltip"
	tablet:Release(self.tooltip)
	self.tooltip = nil
end

function BabelFu.OnLanguageClick(...)
	BabelFu:SelectLanguage(arg[arg.n])
end

----------------------------------------------
-- METHODS                                  --
----------------------------------------------
function BabelFu:Translate(msg, chatType, language, channel)
	if (chatType and self.db.char.types[chatType]) then
		language = self.db.char.language
	end
	self.hooks.SendChatMessage(msg,chatType,language, channel)
end

-----------------------------------------------
-- FUNCTIONS                                 --
-----------------------------------------------
function BabelFu:Cycle()
	BabelFu:SelectLanguage(
	    ((BabelFu.db.char.language or 1) % GetNumLanguages()) + 1)
end

function BabelFu:SelectLanguage(index)
	assert(index <= GetNumLanguages(), "Bad language chosen: " .. index)
	BabelFu.db.char.language = index
	dataobject.text = GetLanguageByIndex(index)
end
